package com.zm.order.tool.server.engine;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Maps;
import com.zm.order.tool.server.constants.ImageEnum;
import org.springframework.util.CollectionUtils;

import java.util.*;

/**
 * 图片热点
 *
 * @author nianchang
 * @ClassName ParseEngine6
 * @date 2021/06/17 10:58 上午
 */
@SuppressWarnings("all")
public class ParseEngine6 {

    public static Map<String, Object> parse(Map<String, Object> BaseMap, Map<String, Object> dataMap, String elName) {
        String id = BaseMap.get("id") != null ? BaseMap.get("id").toString() : "";
        Integer marginTop = BaseMap.get("marginTop") != null ? Integer.valueOf(BaseMap.get("marginTop").toString()) : 0;
        Integer marginBottom = BaseMap.get("marginBottom") != null ? Integer.valueOf(BaseMap.get("marginBottom").toString()) : 0;
        Integer marginLeft = BaseMap.get("marginLeft") != null ? Integer.valueOf(BaseMap.get("marginLeft").toString()) : 0;
        Integer marginRight = BaseMap.get("marginRight") != null ? Integer.valueOf(BaseMap.get("marginRight").toString()) : 0;

        String img = dataMap.get("img") != null ? dataMap.get("img").toString() : "";
        Integer borderRadius = dataMap.get("borderRadius") != null ? Integer.valueOf(dataMap.get("borderRadius").toString()) : 0;

        List<Map> hotList = JSON.parseArray(dataMap.get("data").toString(), Map.class);

        Map<String, Object> source = buildDataSource(elName, marginTop, marginBottom, marginLeft, marginRight,
                id, hotList, img , borderRadius);
        return source;
    }

    private static Map<String, Object> buildDataSource(String elName, Integer marginTop, Integer marginBottom, Integer marginLeft,
                                                       Integer marginRight, String id, List<Map> hotList,
                                                       String img, Integer borderRadius) {
        Map<String, Object> data = new HashMap<>();
        data.put("elName", elName);
        data.put("title", "图片热点");
        Map<String, Object> map = buildCommonStyleMap(marginTop, marginBottom, marginLeft, marginRight, borderRadius);
        data.put("commonStyle", map);
        data.put("isFixed", false);
        data.put("propsValue", buildPropsValue(img, hotList));
        data.put("events", buildEvents());
        data.put("icon", "qimai-B");
        data.put("id", id);
        String miniStyle = BuildStyle.build(map, elName);
        data.put("miniStyle", miniStyle);
        return data;
    }

    private static Map<String, Object> buildEvents() {
        Map<String, Object> eventsMap = new HashMap<>();
        eventsMap.put("type", "");
        eventsMap.put("page", buildPage());
        eventsMap.put("phone", "");
        eventsMap.put("audioUrl", "");
        eventsMap.put("alipay", buildAliPay());
        eventsMap.put("map", buildMap());
        return eventsMap;
    }

    private static Map<String, Object> buildMap() {
        Map<String, Object> map = new HashMap<>();
        map.put("lng", "");
        map.put("lat", "");
        map.put("name", "");
        map.put("address", "");
        return map;
    }

    private static Map<String, Object> buildAliPay() {
        Map<String, Object> alipay = new HashMap<>();
        alipay.put("tntInstId", "");
        alipay.put("scene", "");
        return alipay;
    }

    private static Map<String, Object> buildPage() {
        Map<String, Object> page = new HashMap<>();
        page.put("link", "");
        page.put("linkType", "");
        page.put("linkText", "");
        page.put("extraData", new HashMap<>());
        return page;
    }

    private static Map<String, Object> buildPropsValue(String img, List<Map> hotList) {
        Map<String, Object> propsValue = new HashMap<>();
        propsValue.put("img", img);
        propsValue.put("hotList", buildHotList(hotList));
        return propsValue;
    }

    private static List<Map<String, Object>> buildHotList(List<Map> hotList) {
        List<Map<String, Object>> newHotList = new ArrayList<>();
        if (!CollectionUtils.isEmpty(hotList)) {
            for (Map<String, Object> map : hotList) {
                Map<String, Object> dataMap = new HashMap<>();
                String link = Objects.nonNull(map.get("link")) ? map.get("link").toString() : "";
                String linkText = Objects.nonNull(map.get("link_text")) ? map.get("link_text").toString() : "";
                ImageEnum imageEnum = ImageEnum.getValue(link);
                if (imageEnum != null) {
                    link = imageEnum.getNewValue();
                    linkText = imageEnum.getDesc();
                }
                dataMap.put("width", Objects.nonNull(map.get("width")) ? map.get("width") : 0);
                dataMap.put("height", Objects.nonNull(map.get("height")) ? map.get("height") : 0);
                dataMap.put("left", Objects.nonNull(map.get("left")) ? map.get("left") : 0);
                dataMap.put("top", Objects.nonNull(map.get("top")) ? map.get("top") : 0);
                dataMap.put("borderRadius", Objects.nonNull(map.get("borderRadius")) ? map.get("borderRadius") : 0);
                dataMap.put("link", link);
                dataMap.put("linkType", Objects.nonNull(map.get("linkType")) ? map.get("linkType") : "");
                dataMap.put("linkText", linkText);
                dataMap.put("extraData", Maps.newHashMap());
                newHotList.add(dataMap);
            }
        }
        return newHotList;
    }

    private static Map<String, Object> buildPoints(String activeColor, Double inactiveOpacity, Integer bottomDistance) {
        Map<String, Object> points = new HashMap<>();
        points.put("bottomDistance", bottomDistance);
        points.put("inactiveOpacity", inactiveOpacity);
        points.put("activeColor", activeColor);
        return points;
    }

    private static Map<String, Object> buildCommonStyleMap(Integer marginTop, Integer marginBottom, Integer marginLeft,
                                                           Integer marginRight, Integer borderRadius) {
        Map<String, Object> commonStyle = new HashMap<>();
        commonStyle.put("position", "relative");
        commonStyle.put("height", "");
        commonStyle.put("top", 0);
        commonStyle.put("left", 0);
        commonStyle.put("paddingTop", 0);
        commonStyle.put("paddingLeft", 0);
        commonStyle.put("paddingRight", 0);
        commonStyle.put("paddingBottom", 0);
        commonStyle.put("marginTop", marginTop);
        commonStyle.put("marginLeft", marginLeft);
        commonStyle.put("marginRight", marginRight);
        commonStyle.put("marginBottom", marginBottom);
        commonStyle.put("borderWidth", 0);
        commonStyle.put("borderColor", "transparent");
        commonStyle.put("borderStyle", "solid");
        commonStyle.put("borderRadius", borderRadius);
        commonStyle.put("boxShadow", "");
        commonStyle.put("fontSize", 14);
        commonStyle.put("fontWeight", 400);
        commonStyle.put("lineHeight", 24);
        commonStyle.put("letterSpacing", 0);
        commonStyle.put("textAlign", "left");
        commonStyle.put("color", "#333");
        commonStyle.put("backgroundColor", "");
        commonStyle.put("backgroundImage", "");
        commonStyle.put("backgroundSize", "contain");
        commonStyle.put("backgroundRepeat", "no-repeat");
        commonStyle.put("backgroundPosition", "center");
        commonStyle.put("opacity", 1);
        commonStyle.put("rotate", 0);
        commonStyle.put("zIndex", 1);
        return commonStyle;
    }
}
